#define G_NAME     ""
#define G_RELEASE  ""

# include <windows.h>
# include <stdio.h>
# include <string.h>
# include <stdlib.h>

#define G_WINDOWS
#include "gemplus.h"
#include "wscump2.h"

#define IFD_TYPE  GCR400        /* GCR400    type                                       */
#define IFD_MODE  G_SERIAL      /* serial communication                                 */
#define IFD_PORT  G_COM2        /* Reader Connected on COM 1                            */
#define IFD_BAUD  9600          /* Speed                                                */
#define IFD_IT    0xFF          /* Interrupt                                            */
#define SOFT_COMPUTE -1         /* This value , used in some MPCOS functions,           */


void closesession(INT16 ChannelID)
{
   INT16 
      response;
   
   printf("Close Session: ");
   
   response = G4_CloseSession(ChannelID);
   
   if (response < G_OK){
      printf(" Failure.  ");
      printf("G4_CloseSession returns %d \n",ChannelID);
   }
   else{
      printf("OK \n");
   }
 
}           
void closechannel(INT16 ChannelID)
{
   INT16
      response;

   printf("Close Channel: ");
   
   response = G4_CloseChannel(ChannelID);
   
   if (response < G_OK){
      printf(" Failure  ");
      printf("G4_CloseChannel returns %d \n",response);
   }
   else{
      printf("OK \n");
   }
}

INT16 opensession(INT16 ChannelID)
{
   INT16
      response;
   G4_SESSION_PARAM 
      session; 

   /* Open session --------------------------------------------------------------------*/
  
   session.ICCType = ISOCARD ;
  
   printf("Open Session: ");
   
   response = G4_OpenSession(ChannelID,
                             &session);
   if (response < G_OK){
      printf(" Failure.  ");
      printf("G4_OpenSession returns %d \n",response);
   }
   else{
      printf("OK \n");

   }
return response;
}

INT16 openchannel()
{
	G4_CHANNEL_PARAM
		channel;
	INT16
		ChannelID;

	/* prepares channel parameters                                                       */
	channel.IFDType              = IFD_TYPE;
	channel.IFDMode              = IFD_MODE;
	channel.Comm.Serial.Port     = IFD_PORT;
	channel.Comm.Serial.BaudRate = IFD_BAUD;
	channel.Comm.Serial.ITNumber = IFD_IT;


	/* opens communication with the reader                                               */
	ChannelID = G4_OpenChannel(&channel);
        printf("Open Channel: ");
   if (ChannelID < G_OK)
     printf(" Failure. OpenChannel returns %d \n",ChannelID);
     else printf("OK \n");
return ChannelID;
}

INT16 autentRecip(INT16 ci)
{
#define keylevel 0
#define keyfilenum 0x3F01
#define keynumber 0
int i;
WORD8 pcrandom[8];
WORD8 result[4]; // 4 bytes
WORD8 cardrandom[8];
WORD8 keyref[16]="TEST KEY";//TEST*KEY";

INT16 ans;
for(i=0;i!=8;i++) pcrandom[i]=rand();

ans=G_MPC_SelKey(ci,keylevel,keyfilenum,keynumber,pcrandom,result,cardrandom);
printf("* Select Key: ");
   if (ans < G_OK)
   {  printf(" Failure. %d \n",ans);
   return ans;
   } else printf("OK \n");
ans=G_MPCSM_SetSecureSessionKey(SOFT_COMPUTE,keylevel,
keyfilenum,keynumber,pcrandom,cardrandom,result,keyref);
printf("* SetSecureKey: ");
   if (ans < G_OK) {
   printf(" Failure: %d \n",ans);
   return ans; }
   else printf("OK \n");
return ans;
}

INT16 verifcode(WORD16 ci,char* code)
{
INT16 rep;
#define codenumber 0
if (code==NULL) code="";
rep=G_MPC_VerifyCode(ci,codenumber,code);
printf("Verification du code Secret: ");
   if (rep < G_OK) {
   printf(" Failure: %d \n",rep);
   return rep; }
   else printf("OK \n");
return 0;
}

int main(int nbarg,char* code[])
{
INT16 ci,rep,rep2;
WORD8 DFDescriptor[18];

ci=openchannel();
if (ci<0) {PostQuitMessage(0);return(11);}
rep=opensession(ci);
if (rep<0) {closechannel(ci);PostQuitMessage(0);return(12);}
rep=G_MPC_InitLib(ci,DFDescriptor);
printf("InitLib: ");
   if (rep < G_OK)
   {
printf(" Failure. %d \n",rep);
closesession(ci);
closechannel(ci);
PostQuitMessage(0);
return(13);
   }
   else printf("OK \n");

printf("Autentification: \n");
rep=autentRecip(ci);
   if (rep < G_OK)
{
closesession(ci);
closechannel(ci);
PostQuitMessage(0);
return(14);
}

rep=verifcode(ci,code[1]);
   if (rep < G_OK)
{
closesession(ci);
closechannel(ci);
if (rep==-4501) rep2=16;
else if (rep==-4010) rep2=17;
else rep2=15;
PostQuitMessage(0);
return(rep2);
}



closesession(ci);
closechannel(ci);

PostQuitMessage(0);
return 0;
}